/****************************************************************** MSW *****/
/*  <NAME>      setimon.c                                                   */
/*  <FUNCTION>  setimon main                                                */
/*                                                                          */
/*                          <CREATE> 99/08/04   <CODED BY> T.Hayashi        */
/*  Copyright (C) 1999 T.Hayashi All Rights Reserved                        */
/****************************************************************************/
/*

 <Program modify list>

 <Details Function>
	main

 <Reference Program>
	none

 <Machine>              PC-AT
 <CPU>                  Intel 386
 <OS>                   PC-DOS
 <Language>             C
 <Compiler/Assembler>   BC++ Ver.4.0
*/
/*


*/

#include "setimon.h"

void filecheck(char *setipath,struct state *status,char *hostname)
{

	char pathwork[Buffer_size];		/* fileL̃`FbNp */
	
	sprintf(pathwork,"%sversion.sah",setipath);	/* NCAgVersion check */
	if(access(pathwork,0x00) != 0){
		status->seti_ver = SETI_V1;
	}else{
		status->seti_ver = SETI_V2;
	}

	state_reset(status);							/*  */
//	if(option->co_state == ON){
		status->work_unit_file = check_work_unit(setipath,status->seti_ver);
		status->result_file = check_result(setipath,status->seti_ver);
		status->outfile_file = check_outfile(setipath,status->seti_ver);
//	}
	status->statefile = check_state(status,hostname,setipath,status->seti_ver);
	status->user_file = check_userinfo(status,hostname,setipath,status->seti_ver);

	return;
}

void makeoutdata(struct state status,struct opt option,struct local *localdata,char *hostname)
{

	double t_totaltime;
	double t_endhour;

//	if(option.co_state != ON){
		printf("%s",hostname);

	localdata_reset(localdata);					/*  */
	if( status.statefile == State_FileOK){
		/* % */
		localdata->prog = status.prog * 100;
		
		/* Spike */
		localdata->bs_power = status.bs_power;
		localdata->bs_score = status.bs_score;

		/* Gaussian */
		localdata->bg_score = status.bg_score;
		localdata->bg_power = status.bg_power;
		localdata->bg_chisq = status.bg_chisq;
		localdata->bg_true_mean = status.bg_true_mean;
		localdata->bg_sigma = status.bg_sigma;

		/* totaltime */
		t_totaltime = status.cpu / status.prog;
		if(option.co_total_time == ON){
			localdata->t_hour = (int)(t_totaltime/3600);
			localdata->t_min = (int)( (t_totaltime - ((double)localdata->t_hour * 3600)) / 60);
			localdata->t_sec = t_totaltime - ((double)localdata->t_hour * 3600) - ((double)localdata->t_min * 60);
		}
		/* end hour */
		t_endhour = t_totaltime - status.cpu;
		if(option.co_end_hour == ON){
			localdata->eh_hour = (int)(t_endhour/3600);
			localdata->eh_min = (int)( (t_endhour - ((double)localdata->eh_hour * 3600)) / 60);
			localdata->eh_sec = t_endhour - ((double)localdata->eh_hour * 3600) - ((double)localdata->eh_min * 60);
		}
		
	}
	
	if( status.user_file == ON){
		strcpy(localdata->id,status.id);											/*  */
		strcpy(localdata->key,status.key);											/*  */
		strcpy(localdata->email_addr,status.email_addr);							/*  */
		strcpy(localdata->user_name,status.user_name);								/*  */
		strcpy(localdata->url,status.url);											/*  */
		strcpy(localdata->country,status.country);									/*  */
		strcpy(localdata->postal_code,status.postal_code);							/*  */
		strcpy(localdata->show_name,status.show_name);								/*  */
		strcpy(localdata->show_email,status.show_email);							/*  */
		strcpy(localdata->venue,status.venue);										/*  */
		strcpy(localdata->register_time,status.register_time);						/*  */
		strcpy(localdata->last_wu_time,status.last_wu_time);						/*  */
		strcpy(localdata->last_result_time,status.last_result_time);				/*  */
		localdata->nwus = status.nwus;
		localdata->nresults = status.nresults;
		localdata->total_cpu = status.total_cpu;
		localdata->params_index = status.params_index;
	}
		
//	}else{
	if(option.co_state == ON){
		if(status.seti_ver == SETI_V1){											/* Version 1.xx */
			if(status.work_unit_file == Wtemp){
				localdata->state = State_Data_Receiving;							/* M */
			}else{
//				if( status.statefile != State_Nofile){
				if( status.statefile == State_FileOK){
					if(status.result_file == OK){
						localdata->state = State_Data_Calculation_completion;		/* vZ */
					}else{
						localdata->state = State_Data_Calculation;					/* vZ *//* work_unitL͖mF */
					}
				}else{
					if(status.work_unit_file == Wunit){
//						localdata->state = State_Data_Calculation;					/* vZ *//* result͖mF */
						localdata->state = State_Data_Calculation_wait;				/* vZ҂ */
					}else if(status.result_file == OK){
						localdata->state = State_Data_Sending;						/* M */
					}else if(status.outfile_file == OK){
						localdata->state = State_Data_Calculation_wait;				/* vZ҂ */
					}else{
						localdata->state = State_Data_nothing;						/* f[^ */
					}
				}
			}
		}else{																/* Version 2.00 */
			if( status.statefile == State_FileOK){
				if(status.result_file == OK){
					localdata->state = State_Data_Calculation_completion;		/* vZ */
				}else if(status.work_unit_file == Wunit){
					localdata->state = State_Data_Calculation;					/* vZ */
				}else{
					localdata->state = State_Data_Receiving;					/* M */
				}
			}else{
				if(status.work_unit_file == Wunit){
					localdata->state = State_Data_Calculation_wait;				/* vZ҂ */
				}else if(status.work_unit_file == Wtemp){
					localdata->state = State_Data_Receiving;					/* M */
				}else{
					localdata->state = State_Data_nothing;						/* f[^ */
				}
			}
		}
	}
	
	return;
}

void output(struct state status,struct opt option,struct local localdata)
{
	double zero = 0;
	
	if( option.co_setilog == ON){		/* co_setilog݊\ */
//		printf("\tdate:%s",localdata. );					/* Date & Time */
		printf("\tid:%s\n",localdata.id );					/* User ID */
		printf("\tkey:%s\n",localdata.key );					/* User Key */
		printf("\temail_addr:%s\n",localdata.email_addr );			/* User E-Mail */
		printf("\tuser_name:%s\n",localdata.user_name );			/* User Name */
		printf("\turl:%s\n",localdata.url );					/* User Home Page URL */
		printf("\tcountry:%s\n",localdata.country );				/* User Country */
		printf("\tpostal_code:%s\n",localdata.postal_code );			/* User Postal code */
		printf("\tshow_name:%s\n",localdata.show_name );			/* User Name Open? */
		printf("\tshow_email:%s\n",localdata.show_email );			/* User E-Mail Open? */
		printf("\tvenue:%s\n",localdata.venue );				/*  */
		printf("\tregister_time:%s\n",localdata.register_time );		/*  */
		printf("\tlast_wu_time:%s\n",localdata.last_wu_time );			/*  */
		printf("\tlast_result_time:%s\n",localdata.last_result_time );		/*  */
	}else{
	
		if( status.statefile == State_FileOK){
			if(option.co_prog == ON){
				printf("\t%f\x25",localdata.prog);
			}
			if(option.co_total_time == ON){	/* I܂ł̑ */
				printf("\tTT: %3dh%dm%2.2fsec",localdata.t_hour,localdata.t_min,localdata.t_sec);
			}
			if(option.co_end_hour == ON){	/* I܂ł̗\zԕ\ */
				printf("\tEH: %3dh%dm%2.2fsec",localdata.eh_hour,localdata.eh_min,localdata.eh_sec);
			}
			if(option.co_spike == ON){		/* Spike\ */
				printf("\tSpike: Score= %f ,Power= %f",localdata.bs_score,localdata.bs_power);
			}
			if(option.co_gaussian == ON){	/* Gaussian\ */
				printf("\tGaussian: Score= %f ,Power= %f ,Fit= %f ,TrueMean= %f ,Sigma= %f",localdata.bg_score,localdata.bg_power,localdata.bg_chisq,localdata.bg_true_mean,localdata.bg_sigma);
			}
		}else{	/* vZi\istate.sahƂ̃_~[j */
			if(option.co_prog == ON){
				printf("\t%f\x25%",zero);
			}
		}
		
		if( option.co_userinfo == ON){		/* User\ */
			printf("\t%s",status.key);
			printf("\t%s",localdata.id);
		}
		
		if( option.co_workinfo == ON){		/* WorkUnit\ */
			printf("\t%s",status.key);
			printf("\t%s",localdata.id);
		}
		
		if(option.co_state == ON){
			printf("\t");
			switch(localdata.state){
				case State_Data_nothing:
					printf("Data_nothing");								/* f[^ */
					break;
				case State_Data_Calculation_wait:
					printf("Data_Calculation_wait");					/* vZ҂ */
					break;
				case State_Data_Calculation:
					printf("Data_Calculation");							/* vZ */
					break;
				case State_Data_Calculation_completion:
					printf("Data_Calculation_completion");				/* vZ */
					break;
				case State_Data_Sending:
					printf("Data_Sending");								/* M */
					break;
				case State_Data_Receiving:
					printf("Data_Receiving");							/* M */
					break;
			}
		}
		
		printf("\n");
	}	
	return;

}



int check_work_unit(char *setipath,int seti_ver)
{
	char path[Buffer_size];		/* path쐬p */
	int ret = OK;
	
	sprintf(path,"%swork_unit%s",setipath,vname[seti_ver]);
	
	if(access(path,0x00) != 0){
		/* work_unit.txtȂ */
		sprintf(path,"%swtemp%s",setipath,vname[seti_ver]);
		if(access(path,0x00) != 0){
			/* wtemp.txtȂ */
			ret = NG;
		}else{
			/* wtemp.txt */
			ret = Wtemp;
		}
	}else{
		/* work_unit.txt */
		ret = Wunit;
	}
	
	return(ret);
}

int check_result(char *setipath,int seti_ver)
{
	char path[Buffer_size];		/* path쐬p */
	int ret = OK;
	
	sprintf(path,"%sresult%s",setipath,vname[seti_ver]);
	if(access(path,0x00) != 0){
		/* result.txtȂ */
		ret = NG;
	}else{
		/* result.txt */
		ret = OK;
	}
	
	return(ret);
}

int check_outfile(char *setipath,int seti_ver)
{
	char path[Buffer_size];		/* path쐬p */
	int ret;
	
	sprintf(path,"%soutfile%s",setipath,vname[seti_ver]);
	if(access(path,0x00) != 0){
		/* outfile.txtȂ */
		ret = NG;
	}else{
		/* outfile.txt */
		ret = OK;
	}
	
	return(ret);
}
int check_userinfo(struct state *status,char *hostname,char *setipath,int seti_ver)
{

	FILE *fp_seti;
	char *fget_err2;					/* fgets error check flg */

	char pattern[22][20]={"id","key","email_addr","name","url","country","postal_code","show_name","show_email","venue","register_time","last_wu_time","last_result_time","nwus","nresults","total_cpu","params_index",""};
	int pattern_n = 0;
	int ptr;
	
	char path[Buffer_size];		/* O̓͗p */

	int ret = OFF;

	char buffer2[Buffer_size];
	char word[Word_size];
	int pot_num = 0;

	ret = State_Nodata;				/* user_info.txt̓e݂Ȃ */

	sprintf(path,"%suser_info%s",setipath,vname[status->seti_ver]);
	if((fp_seti=fopen(path,"rt"))==NULL){
//		printf("%s\t%s file open error!!\n",hostname,path);
		ret = State_Nofile;			/* c.txt݂Ȃ */
//		ret = NG;
	}else{
	
		do{
			fget_err2=fgets(buffer2,255,fp_seti);
			if(fget_err2!=NULL){
				getword(buffer2,word);				/* xǂݍ */

				pattern_n = 0;
				do{											/* p^[}b`O */
					ptr=strcmp(word,pattern[pattern_n]);
//					printf("word:%s:%s:%d\n",word,pattern[pattern_n],pattern_n);
					pattern_n++;
				}while(ptr!=0 && strcmp(pattern[pattern_n-1],"")!=0);
				getsym(buffer2);

				switch(pattern_n){
					case UI_ID:
						getword(buffer2,word);	
						strcpy(status->id,word);
						ret = ON;		/* user_info.txt̓e݂ */
						break;

					case UI_KEY:
						getword(buffer2,word);	
						strcpy(status->key,word);
						break;

					case UI_EMAIL_ADDR:
						getword(buffer2,word);	
						strcpy(status->email_addr,word);
						break;

					case UI_NAME:							/* cpu */
						getword4(status->user_name,buffer2);	
						break;
						
					case UI_URL:							/* prog */
						getword(buffer2,word);	
						strcpy(status->url,word);
						break;
								
					case UI_COUNTRY:						/* Spike:Power */
						getword(buffer2,word);	
						strcpy(status->country,word);
						break;
						
					case UI_POSTAL_CODE:						/* Spike:Score */
						getword(buffer2,word);	
						strcpy(status->postal_code,word);
						break;
						
					case UI_SHOW_NAME:
						getword(buffer2,word);	
						strcpy(status->show_name,word);
						break;

					case UI_SHOE_EMAIL:
						getword(buffer2,word);	
						strcpy(status->show_email,word);
						break;

					case UI_VENUE:
						getword(buffer2,word);	
						strcpy(status->venue,word);
						break;

					case UI_REGISTER_TIME:
						getword4(status->register_time,buffer2);	
						break;

					case UI_LAST_WU_TIME:						/* Gaussian:Score */
						getword4(status->last_wu_time,buffer2);	
						break;
						
					case UI_LAST_RESULT_TIME:						/* Gaussian:Sigma */
						getword4(status->last_result_time,buffer2);	
						break;
						
					case UI_NWUS:						/* Gaussian:Power */
						getword(buffer2,word);	
						status->nwus = atol(word);
						break;
						
					case UI_NRESULTS:					/* Gaussian:True Mean */
						getword(buffer2,word);	
						status->nresults = atol(word);
						break;
						
					case UI_TOTAL_CPU:						/* Gaussian:Fit */
						getword(buffer2,word);	
						status->total_cpu = atof(word);
						break;
						
					case UI_PARAMS_INDEX:
						getword(buffer2,word);	
						status->params_index = atol(word);
						break;

					default:
						break;
				}

			}
		}while(fget_err2!=NULL);
		(void)fclose(fp_seti);
	}

	return(ret);
}


int check_state(struct state *status,char *hostname,char *setipath,int seti_ver)
{

	FILE *fp_seti;
	char *fget_err2;					/* fgets error check flg */

	char pattern[22][20]={"ncfft","cr","fl","cpu","prog","bs_power","bs_score","bs_bin","bs_fft_ind","bs_chirp_rate","bs_fft_len","bg_score","bg_sigma","bg_power","bg_true_mean","bg_chisq","bg_bin","bg_fft_ind","bg_chirp_rate","bg_fft_len","bg_pot",""};
	int pattern_n = 0;
	int ptr;
	
	char path[Buffer_size];		/* O̓͗p */

	int ret;

	char buffer2[Buffer_size];
	char word[Word_size];
	int pot_num = 0;

	ret = State_Nodata;				/* state.txt̓e݂Ȃ */

	sprintf(path,"%sstate%s",setipath,vname[status->seti_ver]);
	if((fp_seti=fopen(path,"rt"))==NULL){
//		printf("%s\t%s file open error!!\n",hostname,path);
		ret = State_Nofile;			/* state.txt݂Ȃ */
//		ret = NG;
	}else{
	
		do{
			fget_err2=fgets(buffer2,255,fp_seti);
			if(fget_err2!=NULL){
				getword(buffer2,word);				/* xǂݍ */

				pattern_n = 0;
				do{											/* p^[}b`O */
					ptr=strcmp(word,pattern[pattern_n]);
//					printf("word:%s:%s:%d\n",word,pattern[pattern_n],pattern_n);
					pattern_n++;
				}while(ptr!=0 && strcmp(pattern[pattern_n-1],"")!=0);
				getsym(buffer2);
				getword(buffer2,word);	

				switch(pattern_n){
					case STA_NCFFT:
						status->ncfft = atof(word);
						break;

					case STA_CR:
						status->cr = atof(word);
						break;

					case STA_FL:
						status->fl = atof(word);
						break;

					case STA_CPU:							/* cpu */
						status->cpu = atof(word);
						break;
						
					case STA_PROG:							/* prog */
						status->prog = atof(word);
//						printf("%s\t%f%\n",hostname,prog * 100);
						ret = State_FileOK;		/* state.txt̓e݂ */
						break;
								
					case STA_BS_POWER:						/* Spike:Power */
						status->bs_power = atof(word);
						break;
						
					case STA_BS_SCORE:						/* Spike:Score */
						status->bs_score = atof(word);
						break;
						
					case STA_BS_BIN:
						status->bs_bin = atof(word);
						break;

					case STA_BS_FFT_IND:
						status->bs_fft_ind = atof(word);
						break;

					case STA_BS_CHIRP:
						status->bs_chirp_rate = atof(word);
						break;

					case STA_BS_FFT_LEN:
						status->bs_fft_len = atof(word);
						break;

					case STA_BG_SCORE:						/* Gaussian:Score */
						status->bg_score = atof(word);
						break;
						
					case STA_BG_SIGMA:						/* Gaussian:Sigma */
						status->bg_sigma = atof(word);
						break;
						
					case STA_BG_POWER:						/* Gaussian:Power */
						status->bg_power = atof(word);
						break;
						
					case STA_BG_TRUE_MEAN:					/* Gaussian:True Mean */
						status->bg_true_mean = atof(word);
						break;
						
					case STA_BG_CHISQ:						/* Gaussian:Fit */
						status->bg_chisq = atof(word);
						break;
						
					case STA_BG_BIN:
						status->bg_bin = atof(word);
						break;

					case STA_BG_FFT_IND:
						status->bg_fft_ind = atof(word);
						break;

					case STA_BG_CHIRP:
						status->bg_chirp_rate = atof(word);
						break;

					case STA_BG_FFT_LEN:
						status->bg_fft_len = atof(word);
						break;

					case STA_BG_POT:
						pot_num = atoi(word);
						getsym(buffer2);
						getword(buffer2,word);	
						status->bg_pot[pot_num] = atof(word);
/*						printf("bg_pot[%d]=%f\n",pot_num,status->bg_pot[pot_num]);	/**/
						break;

					default:
						break;
				}

			}
		}while(fget_err2!=NULL);
		(void)fclose(fp_seti);
	}

	return(ret);
}


void check_cmdlin(int argc,char **argv,struct opt *option)
/*

R}h


*/
{
	char pattern[20][20]={"HELP","TIME","VERSION","HOST","NOWTIME","ENDTIME","ENDHOUR","TOTALTIME","STATE","SPIKE","GAUSSIAN","USERINFO","WORKINFO","SETILOG",""};
	int pattern_n = 0;
	int ptr;

	char buffer[Buffer_size];
	char word[Buffer_size];
	char num[Buffer_size];
	
	int count;

	for(count = 1;count < argc;count++){

		str_toupper(argv[count],buffer);			/* 啶ϊ */
//		printf("%s:\n",buffer);
		getword2(buffer,word);						/* IvVǂݍ */
		
		pattern_n = 0;
		do{											/* p^[}b`O */
			ptr=strcmp(word,pattern[pattern_n]);
//			printf("word:%s:%s:%d\n",word,pattern[pattern_n],pattern_n);
			pattern_n++;
		}while(ptr!=0 && strcmp(pattern[pattern_n-1],"")!=0);
	
		switch(pattern_n){
			case Com_HELP:							/* help */
				option->co_help = ON;
				option->view = OFF;
				option->loop = OFF;
				com_help();
				break;
			case Com_TIME:							/* time */
				option->view = ON;					/* \ */
				option->loop = ON;					/* [v */
				getword3(buffer,num);						/* lǂݍ */
				if((strlen(num) == 0) && ( (count+1) < argc )){
					count++;
					str_toupper(argv[count],buffer);			/* 啶ϊ */
					getword3(buffer,num);						/* lǂݍ */
					if(strlen(num) == 0){						/* error */
						printf("bad arg: -time %s\n",argv[count]);
						com_help();
						option->view = OFF;						/* \Ȃ */
						option->loop = OFF;						/* [vȂ */
					}
				}else if(atoi(num) > 0){
//					option->wait_time = atoi(num);
				}else{
					printf("bad arg: -time TIME\n");
					com_help();
					option->view = OFF;						/* \Ȃ */
					option->loop = OFF;						/* [vȂ */
				}
				option->wait_time = atoi(num);
				if(option->loop == ON){
					printf("wait_time:%d\n",option->wait_time);
				}
				break;
			case Com_VER:							/* version */
				option->view = ON;
				if( (count+1) < argc ){
					str_toupper(argv[count+1],buffer);			/* 啶ϊ */
					if(strcmp(buffer,"ON") == 0){
						option->co_version = ON;
						count++;
					}else if(strcmp(buffer,"OFF") == 0){
						option->co_version = OFF;
						count++;
					}else{
						option->co_version = ON;
					}
				}else{
					option->co_version = ON;
				}
				break;
				
			case Com_HOST:							/* host */
				option->co_host = ON;
				option->view = ON;					/* \ */
				if( (count+1) < argc ){
					count++;
					strcpy(option->hostname,argv[count]);		/* hostname i[ */
				}else{
					printf("bad arg: -host\n");
					com_help();
					option->view = OFF;						/* \Ȃ */
					option->loop = OFF;						/* [vȂ */
				}
				break;
			case Com_NOWTIME:						/* nowtime */
				option->co_now_time = ON;
				option->view = ON;					/* \ */
				break;
			case Com_ENDTIME:						/* endtime */
				option->co_end_time = ON;
				option->view = ON;					/* \ */
				break;
			case Com_ENDHOUR:						/* endhour */
				option->co_end_hour = ON;
				option->view = ON;					/* \ */
				break;
			case Com_TOTALTIME:						/* totaltime */
				option->co_total_time = ON;
				option->view = ON;					/* \ */
				break;
			case Com_STATE:							/* state */
				option->co_state = ON;
				option->view = ON;					/* \ */
				break;
				
			case Com_SPIKE:							/* Spike */
				option->co_spike = ON;
				option->view = ON;					/* \ */
				break;
				
			case Com_GAUSSIAN:						/* Gaussian */
				option->co_gaussian = ON;
				option->view = ON;					/* \ */
				break;
				
			case Com_USERINFO:						/* userinfo */
				option->co_userinfo = ON;
				option->view = ON;					/* \ */
				break;

			case Com_WORKINFO:						/* workinfo */
				option->co_workinfo = ON;
				option->view = ON;					/* \ */
				break;

			case Com_SETILOG:						/* setilog */
				option->co_setilog = ON;
				option->co_prog = OFF;				/* vZi\Ȃ */
				option->view = ON;					/* \ */
				break;

			default:								/* ݂ȂIvV */
				printf("bad arg: %s\n",argv[count]);	/* error */
				option->co_help = ON;
				com_help();
				option->view = OFF;
				option->loop = OFF;
				break;
		}
		
	}

	return;
}



void com_help(void)
/*
	help\
*/
{
	printf("options:\n");
	printf("\t-version  \tshow version info\n");
	printf("\t-time TIME\tset repeat time(sec)\n");
	printf("\t-totaltime\tshow total process time\n");
	printf("\t-endhour\tshow process remain time\n");
	printf("\t-host HOSTNAME\tshow HOSTNAME info\n");

	printf("\t-state    \tshow client run mode\n");
	printf("\t-spike    \tshow spike data\n");
	printf("\t-gaussian \tshow gaussian data\n");
	
	printf("\t-help     \tshow help info\n");

	printf("Copyright (c) T.Hayashi,Team Yellow Dwarf,1999-2000\n");
	printf("Email:hayasita@na.rim.or.jp\n");
	printf("http://www.ufg.org/~junk_yard/setiathome/\n");

}

void local_reset(struct local *localdata)
{

	strcpy(localdata->setimon_version,VERSION);			/* setimon version ݒ */

		strcpy(localdata->id,"");											/*  */
		strcpy(localdata->key,"");											/*  */
		strcpy(localdata->email_addr,"");							/*  */
		strcpy(localdata->user_name,"");								/*  */
		strcpy(localdata->url,"");											/*  */
		strcpy(localdata->country,"");									/*  */
		strcpy(localdata->postal_code,"");							/*  */
		strcpy(localdata->show_name,"");								/*  */
		strcpy(localdata->show_email,"");							/*  */
		strcpy(localdata->venue,"");										/*  */
		strcpy(localdata->register_time,"");						/*  */
		strcpy(localdata->last_wu_time,"");						/*  */
		strcpy(localdata->last_result_time,"");				/*  */
		localdata->nwus = 0;
		localdata->nresults = 0;
		localdata->total_cpu = 0;
		localdata->params_index = 0;

}


void option_reset(struct opt *option)
{

	option->co_help = OFF;					/* help\ */
	option->co_time = OFF;					/* setimon̎ss[gԎw */
	option->co_version = ON;				/* S/WVersion\ */
	option->co_host = OFF;					/* HOSTNAME̐i\ */
	option->co_prog = ON;					/* vZi\ */
	option->co_now_time = OFF;				/* ݎ\ */
	option->co_end_time = OFF;				/* \zI\ */
	option->co_end_hour = OFF;				/* I܂ł̗\zԕ\ */
	option->co_total_time = OFF;			/* I܂ł̑ */

	option->co_state = OFF;					/*  */
	option->co_spike = OFF;					/* Spike */
	option->co_gaussian = OFF;				/* Gaussian */
	option->co_userinfo = OFF;				/* [U[\ */
	option->co_workinfo = OFF;				/* WorkUnit\ */
	option->co_setilog = OFF;				/* SETILog݊o */
	
	option->loop = OFF;
	option->wait_time = 0;

}

void state_reset(struct state *status)
{

	status->cpu = 0;						/* Process s */
	status->prog = 0;						/* Progress ͗ */

}


void localdata_reset(struct local *localdata)
{
	int count;

	/* state */
	localdata->ncfft = 0;					/*  */
	localdata->cr = 0;						/*  */
	localdata->fl = 0;						/*  */
	localdata->cpu = 0;						/* Process s */
	localdata->prog = 0;					/* Progress ͗ */
	localdata->bs_power = 0;				/* Spike:Power */
	localdata->bs_score = 0;				/* Spike:Score */
	localdata->bs_bin = 0;					/*  */
	localdata->bs_fft_ind = 0;				/*  */
	localdata->bs_chirp_rate = 0;			/*  */
	localdata->bs_fft_len = 0;				/*  */
	localdata->bg_score = 0;				/* Gaussian:Score */
	localdata->bg_sigma = 0;				/* Gaussian:Sigma */
	localdata->bg_power = 0;				/* Gaussian:Power */
	localdata->bg_true_mean = 0;			/* Gaussian:True Mean */
	localdata->bg_chisq = 0;				/* Gaussian:Fit */
	localdata->bg_bin = 0;					/*  */
	localdata->bg_fft_ind = 0;				/*  */
	localdata->bg_chirp_rate = 0;			/*  */
	localdata->bg_fft_len = 0;				/*  */
	for(count = 0;count < 64;count++){
		localdata->bg_pot[count] = 0;		/*  */
	}
	
	localdata->state = 0;					/* -state */
	localdata->t_hour = 0;
	localdata->t_min = 0;					/* Total Time */
	localdata->t_sec = 0;					/* Total Time */
	localdata->eh_hour = 0;
	localdata->eh_min = 0;					/* I܂ł̗\z A */
	localdata->eh_sec = 0;					/* I܂ł̗\z b */

	return;
}
