#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#ifndef linux
#include <io.h>
#include <dos.h>
#endif

#include "sub.h"

#define VERSION "0.61"			/* Versionݒ */

#define Buffer_size 255
#define Word_size 32

#define OFF	0
#define ON 1

#define NG	0
#define OK 1

#define State_Nodata	0
#define State_Nofile	1
#define State_FileOK	2

#define Wtemp	1
#define Wunit	2

/* command define */
#define Com_HELP		1
#define Com_TIME		2
#define Com_VER			3
#define Com_HOST		4
#define Com_NOWTIME		5
#define Com_ENDTIME		6
#define Com_ENDHOUR		7
#define Com_TOTALTIME	8
#define Com_STATE		9
#define Com_SPIKE		10
#define Com_GAUSSIAN	11
#define Com_USERINFO	12
#define Com_WORKINFO	13
#define Com_SETILOG		14

/* state.sah */
#define STA_NCFFT			1	/* ncfft */			/*  */
#define STA_CR				2	/* cr */			/*  */
#define STA_FL				3	/* fl */			/*  */
#define STA_CPU				4	/* cpu */			/* CPU Time */
#define STA_PROG			5	/* prog */			/* Progress */
#define STA_BS_POWER		6	/* bs_power */		/* Spike:Power */
#define STA_BS_SCORE		7	/* bs_score */		/* Spike:Score */
#define STA_BS_BIN			8	/* bs_bin */		/* Spike: */
#define STA_BS_FFT_IND		9	/* bs_fft_ind */	/* Spike: */
#define STA_BS_CHIRP		10	/* bs_chirp_rate */	/* Spike: */
#define STA_BS_FFT_LEN		11	/* bs_fft_len */	/* Spike: */
#define STA_BG_SCORE		12	/* bg_score */		/* Gaussian:Score */
#define STA_BG_SIGMA		13	/* bg_sigma */		/* Gaussian:Sigma */
#define STA_BG_POWER		14	/* bg_power */		/* Gaussian:Power */
#define STA_BG_TRUE_MEAN	15	/* bg_true_mean */	/* Gaussian:True Mean */
#define STA_BG_CHISQ		16	/* bg_chisq */		/* Gaussian:Fit */
#define STA_BG_BIN			17	/* bg_bin */		/* Gaussian: */
#define STA_BG_FFT_IND		18	/* bg_fft_ind */	/* Gaussian: */
#define STA_BG_CHIRP		19	/* bg_chirp_rate */	/* Gaussian: */
#define STA_BG_FFT_LEN		20	/* bg_fft_len */	/* Gaussian: */
#define STA_BG_POT			21	/* bg_pot */		/*  */

/* work_unit.sah */
#define WU_TYPE					1	/* f[^ */
#define WU_TASK					2	/*  */
#define WU_VERSION				3	/* SETI Ver. */
#define WU_NAME					4	/* Work Unit */
#define WU_DATA_TYPE			5	/*  */
#define WU_DATA_CLASS			6	/*  */
#define WU_SPLITTER_VERSION		7	/* Splitter Ver. */
#define WU_START_RA				8	/* ϑ(From) */
#define WU_START_DEC			9	/* ϑ(From) */
#define WU_END_RA				10	/* ϑ(To) */
#define WU_END_DEC				11	/* ϑ(To) */
#define WU_ANGLE_RANGE			12	/*  */
#define WU_TIME_RECORDED		13	/* ϑ */
#define WU_SUBBAND_CENTER		14	/* Center Freq. */
#define WU_SUBBAND_BASE			15	/* Base Freq. */
#define WU_SUBBAND_SAMPLE_RATE	16	/* Rate */
#define WU_FFT_LEN				17	/*  */
#define WU_IFFT_LEN				18	/*  */
#define WU_SUBBAND_NUMBER		19	/*  */
#define WU_RECEIVER				20	/*  */
#define WU_NSAMPLES				21	/* Samples */
#define WU_TAPE_VERSION			22	/*  */
#define WU_NUM_POSITIONS		23	/*  */

/* user_info.sah */
#define UI_ID				1	/*  */
#define UI_KEY				2	/*  */
#define UI_EMAIL_ADDR		3	/* SETI@homeo^e-mail address */
#define UI_NAME				4	/* SETI@homeo^ */
#define UI_URL				5	/* SETI@homeo^URL */
#define UI_COUNTRY			6	/* SETI@homeo^ */
#define UI_POSTAL_CODE		7	/* SETI@homeo^X֔ԍ */
#define UI_SHOW_NAME		8	/* OJĂ邩 */
#define UI_SHOE_EMAIL		9	/* e-mail addressJĂ邩 */
#define UI_VENUE			10	/*  */
#define UI_REGISTER_TIME	11	/* o^ */
#define UI_LAST_WU_TIME		12	/* WUM */
#define UI_LAST_RESULT_TIME	13	/* ʑM */
#define UI_NWUS				14	/* WUM */
#define UI_NRESULTS			15	/* ʑM */
#define UI_TOTAL_CPU		16	/* Total CPU Time */
#define UI_PARAMS_INDEX		17	/*  */


/* Output status */
#define State_Data_nothing					0
#define State_Data_Calculation				1
#define State_Data_Calculation_completion	2
#define State_Data_Sending					3
#define State_Data_Receiving				4
#define State_Data_Calculation_wait			5

#define SETI_V1		0
#define SETI_V2		1

static char vname[2][6] =
{
	".txt",
	".sah"
};


struct local {
	char setimon_version[Word_size];	/* setimon version */

	/* o͗pf[^ */

	/* state */
	double ncfft;					/*  */
	double cr;						/*  */
	double fl;						/*  */
	double cpu;						/* Process s */
	double prog;					/* Progress ͗ */
	double bs_power;				/* Spike:Power */
	double bs_score;				/* Spike:Score */
	double bs_bin;					/*  */
	double bs_fft_ind;				/*  */
	double bs_chirp_rate;			/*  */
	double bs_fft_len;				/*  */
	double bg_score;				/* Gaussian:Score */
	double bg_sigma;				/* Gaussian:Sigma */
	double bg_power;				/* Gaussian:Power */
	double bg_true_mean;			/* Gaussian:True Mean */
	double bg_chisq;				/* Gaussian:Fit */
	double bg_bin;					/*  */
	double bg_fft_ind;				/*  */
	double bg_chirp_rate;			/*  */
	double bg_fft_len;				/*  */
	double bg_pot[64];				/*  */

	/* work_unit */
	char type[Buffer_size];				/* f[^ */
	char task[Buffer_size];				/*  */
	long version;						/* SETI Ver. */
	char wu_name[Buffer_size];			/* Work Unit */
	char data_type[Buffer_size];		/*  */
	long data_class;					/*  */
	char splitter_version[Buffer_size];	/* Splitter Ver. */
	double start_ra;					/* ϑ(From) */
	double start_dec;					/* ϑ(From) */
	double end_ra;						/* ϑ(To) */
	double end_dec;						/* ϑ(To) */
	double angle_range;					/*  */
	char time_recorded[Buffer_size];	/* ϑ */
	double subband_center;				/* Center Freq. */
	double subband_base;				/* Base Freq. */
	double subband_sample_rate;			/* Rate */
	long fft_len;						/*  */
	long ifft_len;						/*  */
	long subband_number;				/*  */
	char receiver[Buffer_size];			/*  */
	long nsamples;						/* Samples */
	double tape_version;				/*  */
	long num_positions;					/*  */
	
	/* user_info */
	char id[Buffer_size];				/* id */
	char key[Buffer_size];				/* key */
	char email_addr[Buffer_size];		/* email_addr */
	char user_name[Buffer_size];		/*  */
	char url[Buffer_size];				/*  */
	char country[Buffer_size];			/*  */
	char postal_code[Buffer_size];		/*  */
	char show_name[Word_size];		/*  */
	char show_email[Word_size];		/*  */
	char venue[Buffer_size];			/*  */
	char register_time[Buffer_size];	/*  */
	char last_wu_time[Buffer_size];		/*  */
	char last_result_time[Buffer_size];	/*  */
	long nwus;							/*  */
	long nresults;						/*  */
	double total_cpu;					/*  */
	long params_index;					/*  */

	char hostname[Buffer_size];		/* SETI@homeHOST */
	int state;						/* -state */
	int t_hour,t_min;				/* Total Time */
	double t_sec;					/* Total Time */
	int eh_hour,eh_min;				/* I܂ł̗\z A */
	double eh_sec;					/* I܂ł̗\z b */
	
	
	
};

struct state {
	int seti_ver;					/* SETI@homeNCAg̃o[W */
	int statefile;					/* state.txt̗L */
	int work_unit_file;				/* work_unit.txt̗L */
	int result_file;				/* result.txt̗L */
	int outfile_file;				/* outfile.txt̗L */
	int user_file;					/* user_info.sah̗L */

	/* state */
	double ncfft;					/*  */
	double cr;						/*  */
	double fl;						/*  */
	double cpu;						/* Process s */
	double prog;					/* Progress ͗ */
	double bs_power;				/* Spike:Power */
	double bs_score;				/* Spike:Score */
	double bs_bin;					/*  */
	double bs_fft_ind;				/*  */
	double bs_chirp_rate;			/*  */
	double bs_fft_len;				/*  */
	double bg_score;				/* Gaussian:Score */
	double bg_sigma;				/* Gaussian:Sigma */
	double bg_power;				/* Gaussian:Power */
	double bg_true_mean;			/* Gaussian:True Mean */
	double bg_chisq;				/* Gaussian:Fit */
	double bg_bin;					/*  */
	double bg_fft_ind;				/*  */
	double bg_chirp_rate;			/*  */
	double bg_fft_len;				/*  */
	double bg_pot[64];				/*  */

	/* work_unit */
	char type[Buffer_size];				/* f[^ */
	char task[Buffer_size];				/*  */
	long version;						/* SETI Ver. */
	char wu_name[Buffer_size];			/* Work Unit */
	char data_type[Buffer_size];		/*  */
	long data_class;					/*  */
	char splitter_version[Buffer_size];	/* Splitter Ver. */
	double start_ra;					/* ϑ(From) */
	double start_dec;					/* ϑ(From) */
	double end_ra;						/* ϑ(To) */
	double end_dec;						/* ϑ(To) */
	double angle_range;					/*  */
	char time_recorded[Buffer_size];	/* ϑ */
	double subband_center;				/* Center Freq. */
	double subband_base;				/* Base Freq. */
	double subband_sample_rate;			/* Rate */
	long fft_len;						/*  */
	long ifft_len;						/*  */
	long subband_number;				/*  */
	char receiver[Buffer_size];			/*  */
	long nsamples;						/* Samples */
	double tape_version;				/*  */
	long num_positions;					/*  */

	/* user_info */
	char id[Buffer_size];				/* id */
	char key[Buffer_size];				/* key */
	char email_addr[Buffer_size];		/* email_addr */
	char user_name[Buffer_size];		/* user_name */
	char url[Buffer_size];				/* url */
	char country[Buffer_size];			/* country */
	char postal_code[Buffer_size];		/* postal_code */
	char show_name[Word_size];			/*  */
	char show_email[Word_size];			/*  */
	char venue[Buffer_size];			/* venue */
	char register_time[Buffer_size];	/* register_time */
	char last_wu_time[Buffer_size];		/* last_wu_time */
	char last_result_time[Buffer_size];	/* last_result_time */
	long nwus;							/* nwus */
	long nresults;						/* nresults */
	double total_cpu;					/* total_cpu */
	long params_index;					/* params_index */

};

struct opt {						/* IvVwtO */
	int co_help;					/* help\ */
	int co_time;					/* setimon̎ss[gԎw */
	int co_version;					/* S/WVersion\ */
	int co_host;					/* HOSTNAME̐i\ */
	int co_prog;					/* vZi\ */
	int co_now_time;				/* ݎ\ */
	int co_end_time;				/* \zI\ */
	int co_end_hour;				/* I܂ł̗\zԕ\ */
	int co_total_time;				/* I܂ł̑ */
	int co_state;					/* seti@homeNCAgsԕ\ */
	int co_spike;					/* Spike */
	int co_gaussian;				/* Gaussian */
	int co_userinfo;				/* [U[\ */
	int co_workinfo;				/* WorkUnit\ */
	int co_setilog;					/* SETILog݊o */
	
	
	int loop;						/* \邩 */
	int view;						/* \s */
	int wait_time;					/* ss[gԎw */
	char hostname[Buffer_size];		/* hostname -HOST̈ */
};


void check_cmdlin(int argc,char **argv,struct opt *option);			/* R}h */
void filecheck(char *setipath,struct state *status,char *hostname);
void makeoutdata(struct state status,struct opt option,struct local *localdata,char *hostname);
void output(struct state status,struct opt option,struct local localdata);
int check_work_unit(char *setipath,int seti_ver);
int check_result(char *setipath,int seti_ver);
int check_outfile(char *setipath,int seti_ver);
int check_userinfo(struct state *,char *,char *,int seti_ver);			/* user_info.sah̓ǂݏo */
int check_state(struct state *,char *,char *,int seti_ver);			/*  */
void com_help(void);												/* -help R}h */
void local_reset(struct local *localdata);							/*  */
void option_reset(struct opt *option);								/* IvVtOZbg */
void state_reset(struct state *status);								/*  */
void localdata_reset(struct local *localdata);						/*  */


