//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.09.22
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#include <iterator>
#include <iostream.h>
#include <string>               // for string class
#include <io.h>
#include <time.h>

#include "setimon.h"
#include "def.h"
#include "nasino_dic.h"


//***************************************************************************
//---------------------------------------------------------------------------
//	<NAME>		Setimon::init
//
//	<FUNCTION>	
//
//---------------------------------------------------------------------------
//		string setpath		IN		path
//		int					Return	OK : ݒ芮
//									NG : pathversion.sah
//---------------------------------------------------------------------------
int Setimon::init(string setpath)
{
	int ret;
	string path;
	
//	ret = OK;
	
	if(setpath.size() > 0){
		if(setpath.at(setpath.size()-1) != '\\'){
			setpath.append("\\");
		}
		setipath = setpath;
	}
	
	/* version.sah邩 */
	ret = check_version(setipath);
	
	/* state.sah邩 */
	check_state(setipath);
	
	/* work_unit.sah邩 */
	check_work_unit(setipath);
	
	/* result.sah邩 */
	check_result(setipath);
	
	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		Setimon::multiunit_execute
//
//	<FUNCTION>	T|[g\tgŕ̃jbgꍇ̃f[^擾
//
//---------------------------------------------------------------------------
//		int					Return	OK : 擾
//									NG : 擾s
//---------------------------------------------------------------------------
int Setimon::multiunit_execute(void)
{
	int ret;
	string path;
	string calc_path;			// vZ̃jbgPath
	
	cout << "multiunit_execute\n";
	
	if(suporttool == SetiAtHome){
	
	}else if(suporttool == NoExeFile){
		ret = NG;
	}else{
		int loop;
		int count;
		
		unit_data.clear();
		compleat_unit = 0;
		wait_unit = 0;
		
		loop = ON;
		for(count = 0 ; loop == ON ; count++){
			// f[^path̍쐬
			char string_tmp[16];
			if(suporttool == SetiDoubler){
				itoa(count,string_tmp,10);
				path = setipath;
				path.append(SetiDoubler_Unit);
				path.append(string_tmp);
			}else if(suporttool == MultiSeti){
				itoa(count+1,string_tmp,10);
				path = setipath;
				path.append(MultiSeti_Unit);
				if(count < 10){
					path.append("0");
				}
				path.append(string_tmp);
			}
			
//			cout << "path:" << path << "\n";
			
			// path̃f[^𒲂ׂ
			if(access(path.c_str(),0x00) == 0){
				
				path.append("\\");
				if(execute(path) != OK){
					loop = OFF;
				}else{
					cout << "status:" << status << "\n";
					
					if(status == STATES_CALCULATION){					// vZ
						calc_path = path;
						calc_unit = count;
					}else if(status == STATES_CALCULATION_COMPLETION){	// vZ
						compleat_unit++;
					}else if(status == STATES_CALCULATION_WAIT){		// vZҋ@
						wait_unit++;
					}
				}
				
			}else{
				loop = OFF;
			}
			
		}
		unit_num = count-1;
		
//		cout << "calc_path:" << calc_path << "\n";
		execute(calc_path);
		
	
		ret = OK;
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		Setimon::execute
//
//	<FUNCTION>	^ꂽPath̃f[^擾
//
//---------------------------------------------------------------------------
//		string path		f[^擾Path
//						󔒎̓ftHgPathgp
//		return(int)		OK : 擾
//						NG : 擾s
//---------------------------------------------------------------------------
int Setimon::execute(string path)
{
	int ret;
	string datapath;
	
	if(path.size() == 0){
		path = setipath;
	}
	
	unit_data.clear();
	
	// setiathomeversion𓾂
	if(read_version(path) != NG){
//		init(path);

		// version.sah邩
		ret = check_version(path);
	
		// state.sah邩
		check_state(path);
	
		// work_unit.sah邩
		check_work_unit(path);
	
		// result.sah邩
		check_result(path);

		read_state(path);			// state.sah reading
		read_work_unit(path);		// work_unit.sah result.sah reading
		make_status();
		ret = OK;
	}else{
		ret = NG;
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		Setimon::exec_man
//
//	<FUNCTION>	^ꂽPath̃f[^擾
//
//---------------------------------------------------------------------------
//		return(int)		UNIT_SINGLE	: jbg͒P
//						UNIT_MULTI	: jbg͕
//						UNIT_NON	: jbgł
//---------------------------------------------------------------------------
int Setimon::exec_man(void)
{
	int ret;
	int tool;
	
	tool = check_suporttool();
	if(tool == SetiAtHome){
		if(execute("") == OK){
			ret = UNIT_SINGLE;
		}else{
			ret = UNIT_NON;
		}
	}else if((tool == SetiDoubler) || (tool == MultiSeti)){
		if(multiunit_execute() == OK){
			ret = UNIT_MULTI;
		}else{
			ret = UNIT_NON;
		}
	}else{
		ret = UNIT_NON;
	}
	
	return(ret);
}

string Setimon::get_version(void)
{
	return(unit_data[DATA_CLIENT_VERSION]);
}

string Setimon::get_unitdata(string entry)
{
	return(unit_data[entry]);
}

string Setimon::get_monitardata(string entry)
{
	return(monitar_data[entry]);
}

string Setimon::get_unitnum(void)
{
	string ret;
	char string_tmp[16];

	itoa(unit_num,string_tmp,10);
	ret = string(string_tmp);

	return(ret);
}


string Setimon::get_compleat_unitnum(void)
{
	string ret;
	char string_tmp[16];

	itoa(compleat_unit,string_tmp,10);
	ret = string(string_tmp);

	return(ret);
}

string Setimon::get_wait_unitnum(void)
{
	string ret;
	char string_tmp[16];

	itoa(wait_unit,string_tmp,10);
	ret = string(string_tmp);

	return(ret);
}

string Setimon::get_calc_unitnum(void)
{
	string ret;
	char string_tmp[16];

	itoa(calc_unit,string_tmp,10);
	ret = string(string_tmp);

	return(ret);
}

//---------------------------------------------------------------------------
//	<NAME>		set_path
//
//	<FUNCTION>	pathݒ肷
//
//---------------------------------------------------------------------------
//		string setpath		IN		path
//		int					Return	OK : ݒ芮
//									NG : path
//---------------------------------------------------------------------------
int Setimon::set_path(string setpath)
{
	int ret;
	string path;
	
	if(setpath.size() > 0){
		if(setpath.at(setpath.size()-1) != '\\'){		// \łȂ\ǉ
			setpath.append("\\");
		}
		setipath = setpath;
		ret = OK;
	}else{
		ret = NG;
	}

	return(ret);
}

string Setimon::get_path(void)
{
	return(setipath);
}

string Setimon::get_status(void)
{
	return(status);
}

void Setimon::view(void)
{
	for(Data_Iter i=unit_data.begin();i!=unit_data.end();i++){
		cout << (*i).first << ":\t" << (*i).second << "\n";
		
	}
	
	return;
}


int Setimon::make_cpu_time(void)
{
	int ret;
	
	ret = OK;
	
	
	
	
	return(ret);
}

int Setimon::make_progress_time(string request_progress)
{
	int ret;
	time_t long_time;
	struct tm *newtime;
	
	double completion_time;
	double cpu_time;
	double req_prog;
	double prog;
	
	char tmp[64];
	
	if(request_progress.size() > 0){
		cpu_time = atof(get_unitdata(DATA_CPUTIME).c_str());
		prog = atof(get_unitdata(DATA_CLIENT_PROG).c_str());
		req_prog = atof(request_progress.c_str());
	
		if(req_prog != 0){
			completion_time = cpu_time / prog;
	
			completion_time = completion_time / (100 / req_prog  );
	
			completion_time -= cpu_time;
		}else{
			completion_time = -1;
		}
	
		if(completion_time > 0){
	
			time(&long_time);
			long_time += (time_t)completion_time;
			newtime = localtime(&long_time);
		
			sprintf(tmp,"%ld",long_time);
			monitar_data[MONDAT_PROGRESS_TIME] = tmp;
	
			sprintf(tmp,"%d",(unsigned int)(newtime->tm_year + 1900));
			monitar_data[MONDAT_PRG_YEAR] = tmp;
		
			sprintf(tmp,"%d",(unsigned int)(newtime->tm_mon + 1));
			monitar_data[MONDAT_PRG_MONTH] = tmp;
	
			sprintf(tmp,"%d",(unsigned int)(newtime->tm_mday));
			monitar_data[MONDAT_PRG_DAY] = tmp;
	
			sprintf(tmp,"%d",(unsigned int)(newtime->tm_hour));
			monitar_data[MONDAT_PRG_HOUR] = tmp;
	
			sprintf(tmp,"%d",(unsigned int)(newtime->tm_min));
			monitar_data[MONDAT_PRG_MIN] = tmp;
	
			sprintf(tmp,"%d",(unsigned int)(newtime->tm_sec));
			monitar_data[MONDAT_PRG_SEC] = tmp;
			
			ret = OK;
	
		}else{
			ret = NG;
		}
	}else{
		ret = NG;
	}
	
	return(ret);
}


int Setimon::make_finish_time(void)
{
	int ret;
	time_t long_time;
	struct tm *newtime;
	
	double completion_time;
	double cpu_time;
	double prog;
	
	char tmp[64];
	
	ret = OK;
	
	cpu_time = atof(get_unitdata(DATA_CPUTIME).c_str());
	prog = atof(get_unitdata(DATA_CLIENT_PROG).c_str());
	
	completion_time = cpu_time / prog;
	completion_time -= cpu_time;
	
	time(&long_time);
	long_time += (time_t)completion_time;
	newtime = localtime(&long_time);
	
	sprintf(tmp,"%ld",long_time);
	monitar_data[MONDAT_FINISH_TIME] = tmp;
	
	sprintf(tmp,"%d",(unsigned int)(newtime->tm_year + 1900));
	monitar_data[MONDAT_FT_YEAR] = tmp;
	
	sprintf(tmp,"%d",(unsigned int)(newtime->tm_mon + 1));
	monitar_data[MONDAT_FT_MONTH] = tmp;
	
	sprintf(tmp,"%d",(unsigned int)(newtime->tm_mday));
	monitar_data[MONDAT_FT_DAY] = tmp;
	
	sprintf(tmp,"%d",(unsigned int)(newtime->tm_hour));
	monitar_data[MONDAT_FT_HOUR] = tmp;
	
	sprintf(tmp,"%d",(unsigned int)(newtime->tm_min));
	monitar_data[MONDAT_FT_MIN] = tmp;
	
	sprintf(tmp,"%d",(unsigned int)(newtime->tm_sec));
	monitar_data[MONDAT_FT_SEC] = tmp;
	
	
	return(ret);
}

int Setimon::make_completion_time(void)
{
	int ret;
	double completion_time;
	double cpu_time;
	double prog;
	char tmp[64];
	
	unsigned int month;
	unsigned int day;
	unsigned int hour;
	unsigned int min;
	unsigned int sec;
	
	ret = OK;
	
	cpu_time = atof(get_unitdata(DATA_CPUTIME).c_str());
	prog = atof(get_unitdata(DATA_CLIENT_PROG).c_str());
	
	completion_time = cpu_time / prog;
	sprintf(tmp,"%f",completion_time);
	monitar_data[MONDAT_COMPLETION_TIME] = tmp;
	
	hour = (unsigned int)(completion_time/3600);
	sprintf(tmp,"%d",hour);
	monitar_data[MONDAT_COMP_HOUR] = tmp;
	
	min = (unsigned int)( (completion_time - (double)(hour * 3600)) / 60);
	sprintf(tmp,"%d",min);
	monitar_data[MONDAT_COMP_MIN] = tmp;
	
	sec = (unsigned int)(  completion_time - (double)(hour * 3600) - (double)(min * 60) );
	sprintf(tmp,"%d",sec);
	monitar_data[MONDAT_COMP_SEC] = tmp;
	
	
	return(ret);
}


//---------------------------------------------------------------------------
//	<NAME>		Setimon::check_suporttool
//
//	<FUNCTION>	Seti@HomẽT|[g\tggpĂ邩𒲂ׂ
//
//---------------------------------------------------------------------------
//		return(int)		SetiAtHome	: Seti@Home
//						SetiDoubler	: SetiDoubler
//						MultiSeti	: MultiSeti
//						NoExeFile	: st@C
//---------------------------------------------------------------------------
int Setimon::check_suporttool(void)
{
//	int ret;
	string path;

	if(check_version(setipath) == OK){
		suporttool = SetiAtHome;
	}else{
		suporttool = NoExeFile;					// st@C
	}
	
	// SetiDoubler`FbN
	path = setipath;
//	path.append("setidbl.exe");
	path.append(SetiDoubler_Unit);
	path.append("0");
	if(access(path.c_str(),0x00) == 0){
		suporttool = SetiDoubler;
	}
	
	// MultiSeti`FbN
	path = setipath;
//	path.append("MultiSeti.exe");
	path.append(MultiSeti_Unit);
	path.append("01");
	if(access(path.c_str(),0x00) == 0){
		suporttool = MultiSeti;
	}
	
	return(suporttool);
}

//---------------------------------------------------------------------------
//	<NAME>		Setimon::get_suporttool
//
//	<FUNCTION>	Seti@HomẽT|[g\tggpĂ邩𒲂ׂ
//
//---------------------------------------------------------------------------
//		return(string)		SetiAtHome	: Seti@Home
//							SetiDoubler	: SetiDoubler
//							MultiSeti	: MultiSeti
//							NoExeFile	: st@C
//---------------------------------------------------------------------------
string Setimon::get_suporttool(void)
{
	string ret;
	
	switch(suporttool){
		case SetiAtHome:
			ret = "SetiAtHome";
			break;
	
		case SetiDoubler:
			ret = "SetiDoubler";
			break;
	
		case MultiSeti:
			ret = "MultiSeti";
			break;
	
		case NoExeFile:
		default:
			ret = "NoExeFile";
			break;
	
	}
	
	return(ret);
}


//***************************************************************************

int Setimon::check_version(string path)
{
//	string path;

	if(path.size() == 0){
		path = setipath;
	}
//	path = setipath;
	path.append(FILENAME_VERSION);
	
//	cout << "version:" << path << "\n";
	
	if(access(path.c_str(),0x00) != 0){
		version_f = NG;
//		ret = NG;
	}else{
		version_f = OK;
//		ret = OK;
	}
	
	return(version_f);
}

int Setimon::check_state(string path)
{

	if(path.size() == 0){
		path = setipath;
	}

	if(read_state(path) == OK){
		if(get_unitdata(DATA_CPUTIME).size() > 1){
			state_f = OK;
		}else{
			state_f = NG;
		}
	}else{
		state_f = NG;
	}
	
	return(state_f);
}

int Setimon::check_work_unit(string path)
{
//	string path;

	if(path.size() == 0){
		path = setipath;
	}
//	path = setipath;
	path.append(FILENAME_WORK_UNIT);
	if(access(path.c_str(),0x00) != 0){
		workunit_f = NG;
	}else{
		workunit_f = OK;
	}
	
	return(workunit_f);
}

int Setimon::check_result(string path)
{
//	string path;

	if(path.size() == 0){
		path = setipath;
	}
//	path = setipath;
	path.append(FILENAME_RESULT);
	if(access(path.c_str(),0x00) != 0){
		/* result.sahȂ */
		result_f = NG;
	}else{
		result_f = OK;
	}
	
	return(result_f);
}



int Setimon::make_status(void)
{
	int ret;
	
	ret = OK;
	
	if(state_f == OK){
		if(result_f == OK){
			status = STATES_CALCULATION_COMPLETION;		// vZ
		}else if(workunit_f == OK){
			status = STATES_CALCULATION;				// vZ
		}else{
			status = STATES_UNKNOUN;					// ̑̏
		}
	}else{
		if(workunit_f == OK){
			status = STATES_CALCULATION_WAIT;			// vZ҂
		}else if(result_f == OK){
			status = STATES_UNKNOUN;					// ̑̏
		}else{
			status = STATES_NODATA;						// f[^
		}
	}
	
	return(ret);
}


int Setimon::read_state(string path)
{
	FILE *fp_seti;
	char *fget_err2;					/* fgets error check flg */
	int ret;
//	string path;
	
	if(path.size() == 0){
		path = setipath;
	}
	
//	path = setipath;
	path.append(FILENAME_STATE);
	if(access(path.c_str(),0x00) != 0){
		/* version.txtȂ */
		state_f = NG;
		ret = NG;
	}else{
		ret = OK;
		
		if((fp_seti=fopen(path.c_str(),"rt"))==NULL){
			
		}else{
			string buffer;
			string entry;
			string data;
			do{
				fget_err2=dic_fgetline(&buffer,fp_seti);
				dic_getword(&entry,&buffer,DIC_GET_EQ_LEFT);
				dic_getsym(&data,&buffer);						// = ̂Ă
				dic_getword(&data,&buffer,DIC_GET_DICWORD);
				unit_data[entry] = data;
			}while(fget_err2!=NULL);
			(void)fclose(fp_seti);
		}
		
		if(get_unitdata(DATA_CPUTIME).size() > 1){
			state_f = OK;
		}else{
			state_f = NG;
		}
		
	}
	
	return(ret);
	
}


int Setimon::read_work_unit(string path)
{
	
	FILE *fp_seti;
	char *fget_err2;					/* fgets error check flg */
	int ret;
//	string path;

	if(path.size() == 0){
		path = setipath;
	}
	
//	path = setipath;
	path.append(FILENAME_WORK_UNIT);
	if(access(path.c_str(),0x00) != 0){
		/* version.txtȂ */
		path = setipath;
		path.append(FILENAME_RESULT);
		if(access(path.c_str(),0x00) != 0){
			ret == NG;
		}else{
			ret = OK;
		}
	}else{
		ret = OK;
	}
	
	if(ret == OK){
		
		if((fp_seti=fopen(path.c_str(),"rt"))==NULL){
			
		}else{
			string buffer;
			string entry;
			string data;
			int loop;
			loop = ON;
			do{
				fget_err2=dic_fgetline(&buffer,fp_seti);
				dic_getword(&entry,&buffer,DIC_GET_EQ_LEFT);
				if(entry.compare("end_seti_header")!=0){
					dic_getsym(&data,&buffer);						// = ̂Ă
					dic_getword(&data,&buffer,DIC_GET_DICWORD);
					unit_data[entry] = data;
				}else{
					loop = OFF;
				}
			}while(fget_err2!=NULL && loop == ON);
			(void)fclose(fp_seti);
			
		}
		
	}
	
	return(ret);
}


int Setimon::read_version(string path)
{
	FILE *fp_seti;
	char *fget_err2;					/* fgets error check flg */
	int ret;
//	string path;
	string version;

	if(path.size() == 0){
		path = setipath;
	}
	
//	path = setipath;
	path.append(FILENAME_VERSION);
	if(access(path.c_str(),0x00) != 0){
		/* version.txtȂ */
//		cout << FILENAME_VERSION << "Ȃ\n";
		ret = NG;
	}else{
		/* version.txt */
//		cout << FILENAME_VERSION << "\n";
		ret = OK;
		
		if((fp_seti=fopen(path.c_str(),"rt"))==NULL){
			
		}else{
			string buffer;
			string word;
			string word2;
			do{
				fget_err2=dic_fgetline(&buffer,fp_seti);
				
				dic_getword(&word,&buffer,DIC_GET_EQ_LEFT);
				dic_getsym(&word2,&buffer);
				dic_getword(&word2,&buffer,DIC_GET_DICWORD);
				if(word.compare("major_version")==0){
					version = word2;
				}else if(word.compare("minor_version")==0){
					if(word2.size() == 1){
						version.append(".0");
					}else{
						version.append(".");
					}
					version.append(word2);
				}
				
			}while(fget_err2!=NULL);
			(void)fclose(fp_seti);
			
			unit_data[DATA_CLIENT_VERSION] = version;
			
//			cout << setimon_data[DATA_VERSION] << "\n";
		}
		
	}
	
	return(ret);
}

