//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.09.22
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#ifndef setimon_h
#define setimon_h
//-----
#include <iterator>
#include <iostream.h>
#include <string>               // for string class
#include <map>


//***************************************************************************
#define FILENAME_VERSION		"version.sah"
#define FILENAME_STATE			"state.sah"
#define FILENAME_WORK_UNIT		"work_unit.sah"
#define FILENAME_RESULT			"result.sah"

#define DATA_CLIENT_VERSION		"client_version"	// NCAgVersion
#define DATA_CLIENT_PROG		"prog"				// i
#define DATA_CPUTIME			"cpu"				// CPU Time
#define DATA_NAME				"name"				// WorkUnit name

#define MONDAT_COMPLETION_TIME	"mondat_completion_time"	// ԗ\zb
#define MONDAT_COMP_YEAR		"mondat_comp_year"			// ԗ\z@N
#define MONDAT_COMP_MONTH		"mondat_comp_month"			// ԗ\z@
#define MONDAT_COMP_DAY			"mondat_comp_day"			// ԗ\z@
#define MONDAT_COMP_HOUR		"mondat_comp_hour"			// ԗ\z@
#define MONDAT_COMP_MIN			"mondat_comp_min"			// ԗ\z@
#define MONDAT_COMP_SEC			"mondat_comp_sec"			// ԗ\z@b

#define MONDAT_FINISH_TIME		"mondat_finish_time"		// \zb
#define MONDAT_FT_YEAR			"mondat_ft_year"			// \z@N
#define MONDAT_FT_MONTH			"mondat_ft_month"			// \z@
#define MONDAT_FT_DAY			"mondat_ft_day"				// \z@
#define MONDAT_FT_HOUR			"mondat_ft_hour"			// \z@
#define MONDAT_FT_MIN			"mondat_ft_min"				// \z@
#define MONDAT_FT_SEC			"mondat_ft_sec"				// \z@b

#define MONDAT_PROGRESS_TIME	"mondat_progress_time"		// i\zb
#define MONDAT_PRG_YEAR			"mondat_prg_year"			// i\z@N
#define MONDAT_PRG_MONTH		"mondat_prg_month"			// i\z@
#define MONDAT_PRG_DAY			"mondat_prg_day"			// i\z@
#define MONDAT_PRG_HOUR			"mondat_prg_hour"			// i\z@
#define MONDAT_PRG_MIN			"mondat_prg_min"			// i\z@
#define MONDAT_PRG_SEC			"mondat_prg_sec"			// i\z@b

#define STATES_UNKNOUN					"unknown"
#define STATES_NODATA					"no data"
#define STATES_CALCULATION_WAIT			"Calculation Wait"
#define STATES_CALCULATION				"Calculation"
#define STATES_CALCULATION_COMPLETION	"Calculation Completion"

// Seti@HomẽT|[g\tg
#define SetiAtHome		0	// Seti@Home
#define SetiDoubler		1	// SetiDoubler
#define MultiSeti		2	// MultiSeti
#define NoExeFile		3	// st@C

#define SetiDoubler_Unit	"unit"
#define MultiSeti_Unit		"U"

#define UNIT_NON			0
#define UNIT_SINGLE			1
#define UNIT_MULTI			2

typedef map<string,string>		Data_Array;			// f[^̌^w
typedef pair<string,string>		Data_Array_Pair;
typedef Data_Array::const_iterator		Data_Iter; 
typedef pair<Data_Iter, Data_Iter>		Data_IterPair; 

class Setimon{
	Data_Array unit_data;
	Data_Array_Pair entrydata;
	
	Data_Array monitar_data;
	
	string setipath;				// Seti@HomePath
	string status;					// SETI@HOMĚ݂̓
	
	unsigned int version_f;
	unsigned int state_f;
	unsigned int workunit_f;
	unsigned int result_f;
	unsigned int suporttool;		// T|[g\tg̎
	unsigned int unit_num;			// [Njbǧ
	unsigned int compleat_unit;		// vZjbǧ
	unsigned int wait_unit;			// vZҋ@̃jbǧ
	unsigned int calc_unit;			// vZ̃jbgio[
	
	int check_version(string path);		// version.sahL邩
	int check_state(string path);			// Lstate.sahL邩
	int check_work_unit(string path);		// work_unit.sah邩
	int check_result(string path);			// result.sah邩
	
	int read_version(string path);
	int read_state(string path);
	int read_work_unit(string path);
	int make_status(void);
public:
	int init(string setipath);
	int check_suporttool(void);		// Seti@HomẽT|[g\tggpĂ邩𒲂ׂ
	string get_suporttool(void);	// Seti@HomẽT|[g\tg̎ނԂ
	void view(void);
	
	int execute(string path);
	int multiunit_execute(void);	// T|[g\tgŕ̃jbgꍇ̃f[^擾
	int exec_man(void);				// f[^擾}l[W
	
	int make_cpu_time(void);
	int make_finish_time(void);
	int make_completion_time(void);
	int make_progress_time(string request_progress);
	
	string get_unitnum(void);
	string get_compleat_unitnum(void);
	string get_wait_unitnum(void);	// 
	string get_calc_unitnum(void);
	
	
	int set_path(string setipath);			// Seti@HomePath̐ݒ
	string get_path(void);
	string get_version(void);
	string get_status(void);
	string get_unitdata(string entry);
	string get_monitardata(string entry);
};

#endif
