//---------------------------------------------------------------------------
//	Takahiro Hayashi 2002.09.22
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------
#include "saori.h"
#include "setimon_main.h"
#include "setimon.h"
#include "def.h"
#include "nasino_dic.h"

Setimon setimon;

int setimon_ini(void)
{
	int ret;
	
//	ret = setimon.init(SETI_DEFAULT_PATH);
	ret = setimon.set_path(SETI_DEFAULT_PATH);
	
	setimon.check_suporttool();
	
	return(ret);
}

int setimon_main(Saori_data *saoridata)
{
	int ret;
	string setipath;
	int exec_ret;

	ret = 0;
	exec_ret = 0;
	if((saoridata->get_argument(0)).size() == 0){
		// s
		int tool;
		
		tool = setimon.check_suporttool();
		if(tool == SetiAtHome){
			if(setimon.execute("") == OK){
				double progtmp;
				char tmp[32];
				
				ret = 200;
				saoridata->set_result(setimon.get_status());
				
				saoridata->set_value(setimon.get_unitdata(DATA_CLIENT_PROG),0);
				
				progtmp = atof(setimon.get_unitdata(DATA_CLIENT_PROG).c_str());
				progtmp *= 100;
				sprintf(tmp,"%d",(int)progtmp);
				saoridata->set_value(tmp,1);
				
				sprintf(tmp,"%.2f",progtmp);
				saoridata->set_value(tmp,2);
				
				saoridata->set_value(setimon.get_unitdata(DATA_NAME),3);
			}else{
				ret = 500;
			}
		}else{
			if(setimon.multiunit_execute() == OK){
				ret = 200;
				double progtmp;
				char tmp[32];
				
				ret = 200;
				saoridata->set_result(setimon.get_status());
				
				saoridata->set_value(setimon.get_unitdata(DATA_CLIENT_PROG),0);
				
				progtmp = atof(setimon.get_unitdata(DATA_CLIENT_PROG).c_str());
				progtmp *= 100;
				sprintf(tmp,"%d",(int)progtmp);
				saoridata->set_value(tmp,1);
				
				sprintf(tmp,"%.2f",progtmp);
				saoridata->set_value(tmp,2);
				
				saoridata->set_value(setimon.get_unitdata(DATA_NAME),3);
				
				saoridata->set_value(setimon.get_suporttool(),4);					// T|[g\tg̖
				saoridata->set_value(setimon.get_unitnum(),5);						// jbǧ
				saoridata->set_value(setimon.get_compleat_unitnum(),6);				// vZjbg
				saoridata->set_value(setimon.get_wait_unitnum(),7);					// vZҋ@̃jbǧ
				saoridata->set_value(setimon.get_calc_unitnum(),8);					// s̃jbgԍ
			}else{
				ret = 500;
			}
		}
	
	}else if((saoridata->get_argument(0)).compare(COMMAND_CLIENT_VERSION)==0){
		// o[W
//		if(setimon.execute("") == OK){
		if(setimon.exec_man() != UNIT_NON){
			ret = 200;
			saoridata->set_result(setimon.get_unitdata(DATA_CLIENT_VERSION));
			saoridata->set_value(setimon.get_unitdata(DATA_CLIENT_PROG),0);
			saoridata->set_value(setimon.get_unitdata(DATA_CPUTIME),1);
			saoridata->set_value(setimon.get_unitdata(DATA_NAME),2);
			saoridata->set_value(setimon.get_suporttool(),4);					// T|[g\tg̖
		}else{
			ret = 500;
		}
	
	}else if((saoridata->get_argument(0)).compare(COMMAND_SETPATH)==0){
		// Path ݒ
		if((saoridata->get_argument(1)).size() != 0){
//			if(setimon.init(saoridata->get_argument(1)) == OK){
			if(setimon.set_path(saoridata->get_argument(1)) == OK){
				int tool;
				
				tool = setimon.check_suporttool();
				if(tool == SetiAtHome){
				
					if(setimon.execute("") == OK){
						ret = 200;
						saoridata->set_result(setimon.get_unitdata(DATA_CLIENT_VERSION));
						saoridata->set_value(setimon.get_unitdata(DATA_CLIENT_PROG),0);
						saoridata->set_value(setimon.get_unitdata(DATA_CPUTIME),1);
						saoridata->set_value(setimon.get_unitdata(DATA_NAME),2);
						saoridata->set_value(escapeencode(setimon.get_path()),3);
						saoridata->set_value(setimon.get_suporttool(),4);					// T|[g\tg̖
						saoridata->set_value("1",5);										// jbǧ
					}else{
						ret = 500;
					}
				}else{
					if(setimon.multiunit_execute() == OK){
						ret = 200;
						saoridata->set_result(setimon.get_unitdata(DATA_CLIENT_VERSION));
						saoridata->set_value(setimon.get_unitdata(DATA_CLIENT_PROG),0);
						saoridata->set_value(setimon.get_unitdata(DATA_CPUTIME),1);
						saoridata->set_value(setimon.get_unitdata(DATA_NAME),2);
						saoridata->set_value(escapeencode(setimon.get_path()),3);
						saoridata->set_value(setimon.get_suporttool(),4);					// T|[g\tg̖
						saoridata->set_value(setimon.get_unitnum(),5);						// jbǧ
						saoridata->set_value(setimon.get_compleat_unitnum(),6);				// vZjbg
						saoridata->set_value(setimon.get_wait_unitnum(),7);					// vZҋ@̃jbǧ
						saoridata->set_value(setimon.get_calc_unitnum(),8);					// s̃jbgԍ
					}else{
						ret = 500;
					}
				}
			}else{
				ret = 500;
			}
		}else{
			ret = 500;
		}
	
	}else if((saoridata->get_argument(0)).compare(COMMAND_GETPATH)==0){
		// Path Ԃ
		ret = 200;
		saoridata->set_result(escapeencode(setimon.get_path()));
	
	}else if((saoridata->get_argument(0)).compare(COMMAND_CPU_TIME)==0){
//		if(setimon.execute("") == OK){
		if(setimon.exec_man() != UNIT_NON){
			
			ret = 200;
			saoridata->set_result(setimon.get_unitdata(DATA_CPUTIME));
			saoridata->set_value(setimon.get_unitdata(DATA_CLIENT_PROG),0);
			saoridata->set_value(setimon.get_unitdata(DATA_CPUTIME),1);
			saoridata->set_value(setimon.get_unitdata(DATA_NAME),2);
		}else{
			ret = 500;
		}
		
	}else if((saoridata->get_argument(0)).compare(COMMAND_FINISH_TIME)==0){
//		if(setimon.execute("") == OK){
		if(setimon.exec_man() != UNIT_NON){
			setimon.make_finish_time();
			
			ret = 200;
			saoridata->set_result(setimon.get_monitardata(MONDAT_FINISH_TIME));
			saoridata->set_value(setimon.get_monitardata(MONDAT_FT_YEAR),0);
			saoridata->set_value(setimon.get_monitardata(MONDAT_FT_MONTH),1);
			saoridata->set_value(setimon.get_monitardata(MONDAT_FT_DAY),2);
			saoridata->set_value(setimon.get_monitardata(MONDAT_FT_HOUR),3);
			saoridata->set_value(setimon.get_monitardata(MONDAT_FT_MIN),4);
			saoridata->set_value(setimon.get_monitardata(MONDAT_FT_SEC),5);
		}else{
			ret = 500;
		}
		
	}else if((saoridata->get_argument(0)).compare(COMMAND_COMP_TIME)==0){
//		if(setimon.execute("") == OK){
		if(setimon.exec_man() != UNIT_NON){
			setimon.make_completion_time();
			
			ret = 200;
			saoridata->set_result(setimon.get_monitardata(MONDAT_COMPLETION_TIME));
			saoridata->set_value(setimon.get_monitardata(MONDAT_COMP_YEAR),0);
			saoridata->set_value(setimon.get_monitardata(MONDAT_COMP_MONTH),1);
			saoridata->set_value(setimon.get_monitardata(MONDAT_COMP_DAY),2);
			saoridata->set_value(setimon.get_monitardata(MONDAT_COMP_HOUR),3);
			saoridata->set_value(setimon.get_monitardata(MONDAT_COMP_MIN),4);
			saoridata->set_value(setimon.get_monitardata(MONDAT_COMP_SEC),5);
		}else{
			ret = 500;
		}
		
	}else if((saoridata->get_argument(0)).compare(COMMAND_PROGRESS_TIME)==0){
//		if(setimon.execute("") == OK){
		if(setimon.exec_man() != UNIT_NON){
			if(setimon.make_progress_time(saoridata->get_argument(1)) == OK){
			
				ret = 200;
				saoridata->set_result(setimon.get_monitardata(MONDAT_PROGRESS_TIME));
				saoridata->set_value(setimon.get_monitardata(MONDAT_PRG_YEAR),0);
				saoridata->set_value(setimon.get_monitardata(MONDAT_PRG_MONTH),1);
				saoridata->set_value(setimon.get_monitardata(MONDAT_PRG_DAY),2);
				saoridata->set_value(setimon.get_monitardata(MONDAT_PRG_HOUR),3);
				saoridata->set_value(setimon.get_monitardata(MONDAT_PRG_MIN),4);
				saoridata->set_value(setimon.get_monitardata(MONDAT_PRG_SEC),5);
			}else{
				ret = 500;
			}
		}else{
			ret = 500;
		}
		
	}else if((saoridata->get_argument(0)).compare(COMMAND_CHECK_SUPORTTOOLS)==0){
		// pathɂǂȎsjbĝ𒲍
		ret = 200;
		saoridata->set_result(setimon.get_suporttool());
	
	}else{
		ret = 400;
	}
		
//	cout << "ret: "<< ret << ": exec_ret: " << exec_ret << "\n";
	

	return(ret);
}


